<?php function prepare_lecture_reservable_place_classroom_dataset($dbconn,$lctr_id,$lecture=false,$course=false,$setfull=false,$clsr_id=false,$plc_id=false) { $dataset=array(); if (!$lecture) $lecture=db_load_lecture_by_id($dbconn,$lctr_id); if (!$course) $course=db_load_course_by_id($dbconn,$lecture['cs_id']); $countlist=db_load_lecture_size_by_place_classroom($dbconn,$lctr_id); $clsr_lctr_size=rowset2multimap($countlist,'clsr_id'); $clsr_ids=array_keys($clsr_lctr_size); $classrooms=db_load_classrooms($dbconn,$clsr_ids); $id2place=rowset2map(db_load_places($dbconn,array_projection($countlist,'plc_id')),'plc_id'); $id2classroom=rowset2map($classrooms,'clsr_id'); $lecture_size=0; foreach ($countlist as $cl) $lecture_size+=$cl['lctr_size']; $dataset['CLASSROOM']=array(); $dataset['lecture_size']=$lecture_size; $dataset['total_vacancy']=0; foreach ($classrooms as $c) { $size=$clsr_lctr_size[$c['clsr_id']]; $c+=$id2classroom[$c['clsr_id']]; $c['PLACE']=array(); foreach ($size as $s) { $place=array( 'plc_id'=>$s['plc_id'], 'plc_name'=>$id2place[$s['plc_id']]['plc_name'], 'SELECTED'=>$plc_id==$s['plc_id'] && $clsr_id==$c['clsr_id']?array(0):array(), 'seats_avail'=>min($course['cs_member_max']-$lecture_size,$s['clsr_size']-$s['lctr_size']) ); $place['UNSELECTED']=$place['SELECTED']?array():array(0); $dataset['total_vacancy']+=$place['seats_avail']; if ($place['seats_avail']) array_push($c['PLACE'],$place); else if ($setfull) { $place['FULL']=array(0); array_push($c['PLACE'],$place); } } if ($c['PLACE']) array_push($dataset['CLASSROOM'],$c); else if ($setfull) { $c['FULL']=array(0); array_push($dataset['CLASSROOM'],$c); } } return $dataset; } function set_lecture_unit_income($dbconn,$lctr_id,$lctr_minutes,$course) { $revenue=$course['cs_price_base']+($course['cs_minutes_step']?($lctr_minutes-$course['cs_minutes_min'])/$course['cs_minutes_step']*$course['cs_price_step']:0); $expense=$course['cs_lecture_cost']; $tax=$revenue*$course['cs_price_taxrate']; db_set_lecture_unit_income($dbconn,$lctr_id,$revenue,$expense,$tax); } function prepare_lecture_reserve_dataset($DBConn,$lecture,$course,$is_input,$staff=false,$inputdata=array(),$tunermap_addon=array()) { $timezone_bias_seconds=get_user_time_zone()*60; $mb_id=current_mb_id(); $dataset=array(); $dataset+=$course; $dataset+=$lecture; if ($is_input) { $dataset['RESERVE']=array(0); $dataset['ENTERING']=array(0); } else { $dataset['CONFIRM']=array(0); $dataset['CONFIRMING']=array(0); } if ($mb_id==$course['mb_id_owner']) { $dataset['ERROR-OWNER-RESERVE']=array(0); $dataset['RESERVE']=array(); } if (datetime_to_seconds($lecture['lctr_deadline'])<=uniwits_time()) { $dataset['ERROR-DEADLINE-OVER']=array(0); $dataset['RESERVE']=array(); } if ($mb_id) { $reserve_count=db_count_reservations_of_lecture($DBConn,$lecture['lctr_id'],$mb_id); if ($reserve_count) { $dataset['ERROR-ALREADY-RESERVED']=array(0); $dataset['RESERVE']=array(); } } $optc=$inputdata['optc']; $optc=$optc?array_true_entries_only($optc):null; $dataset['option-count-param']=$optc?'-'.rewrite_build_query(array('optc'=>$optc)):''; if (!$staff) $staff=db_load_staff_of_lectures($DBConn,$lecture['lctr_id']); $dataset['STAFF']=$staff; $classroom=db_load_classroom($DBConn,$lecture['clsr_id']); $dataset+=prepare_lecture_reservable_place_classroom_dataset($DBConn,$lecture['lctr_id'],$lecture,$course,true,$inputdata['clsr_id'],$inputdata['plc_id']); $lecture_size=$dataset['lecture_size']; $dataset['clsr_name']=$classroom['clsr_name']; $dataset+=array_key_prepend(split_datetime($lecture['lctr_since'],$timezone_bias_seconds),'since_'); $dataset+=array_key_prepend(split_datetime($lecture['lctr_expire'],$timezone_bias_seconds),'expire_'); if ($dataset['since_year']!=$dataset['expire_year'] || $dataset['since_month']!=$dataset['expire_month'] || $dataset['since_day']!=$dataset['expire_day']) $dataset['DAY-DIFFERRED']=array(0); else $dataset['DAY-SAME']=array(0); $dataset['since_weekday']=datetime_to_weekday($lecture['lctr_since'],$timezone_bias_seconds); $dataset['expire_weekday']=datetime_to_weekday($lecture['lctr_expire'],$timezone_bias_seconds); $dataset['RT-FORMAL']=$course['cs_autoconfirm']=='YES' || $course['cs_autoconfirm']=='ALLBUTONE' && $lecture_size>0 ?array(0):array(); $dataset['RT-PROVISIONAL']=$dataset['RT-FORMAL']?array():array(0); $since_sec=datetime_to_seconds($lecture['lctr_since']); $expire_sec=datetime_to_seconds($lecture['lctr_expire']); $minutes=($expire_sec-$since_sec)/60; $dataset+=prepare_IDR_request_dataset($DBConn,$lecture['cs_id']); $options=false; $dataset+=prepare_options_dataset( $DBConn, $lecture['cs_id'], null, $is_input || !is_array($optc)?null:array_keys($optc), array( 'for_course_detail'=>true, 'input_count'=>$is_input, 'confirm_count'=>!$is_input, 'optc'=>$inputdata['optc'], 'count_range_off'=>!$is_input, 'price_detail_off'=>!$is_input, 'total_price'=>!$is_input, 'thumbnail_off'=>!$is_input, 'minutes'=>$minutes )+$course+$tunermap_addon, $options); if ($dataset['ERROR-OPTION-SOMEERROR']) $dataset['CONFIRM']=array(); if (count_true_entries($inputdata['optc'])<$reserve_options_min) { $dataset['ERROR-OPTION-MORE']=array(0); $dataset['CONFIRM']=array(); } $dataset+=prepare_lecture_price_dataset($course,$minutes); if (!$dataset['total_vacancy']) $dataset['ERROR-LECTURE-FULL']=array(0); else $dataset['RESERVABLE']=array(0); $dataset['MESSAGE-ROW']=$is_input || $inputdata['message']?array(0):array(); $total_price=$dataset['reserve_lecture_price']; $total_price_withtax=$dataset['reserve_lecture_price_withtax']; if (is_array($dataset['OPTION'])) { foreach ($dataset['OPTION'] as $op) { $total_price+=$op['price']; $total_price_withtax+=$op['price_with_tax']; } } $dataset['total_price']=$total_price; $dataset['total_price_withtax']=$total_price_withtax; $dataset['DISPLAY-TOTAL-PRICE']=$is_input?array():array(0); $dataset+=$inputdata; $dataset['confirm.statement']=db_load_course_info_value($DBConn,$lecture['cs_id'],'reserve.confirm.statement'); $dataset['CONFIRM-STATEMENT']=$dataset['confirm.statement']?array(0):array(); return $dataset; } ?>